<template>
  <div class="box-responsive">
    <div v-if="msg_done" class="box-done">{{ msg_done }}</div>
    <div v-if="msg_err" class="box-err">{{ msg_err }}</div>
    <table class="table-campaign" v-for="area in campaign_detail.areas" :key="area.id">
      <tr>
        <th class="column-area">Area</th>
        <th class="column-place">Place</th>
        <th colspan="4" class="column-session">Session</th>
      </tr>
      <tr v-for="(place, index_place) in area.places" :key="place.id">
        <td>{{ index_place == 0 ? area.name : '' }}</td>
        <td>{{ place.name }}</td>
        <td v-for="session in place.sessions" :key="session.id" @click="sessionDetail(session)" class="text-center">
          <div v-if="session.title" :class="{'active': session.type === 'normal' || user_registration_session_ids.includes(session.id)}">
            {{ formatTimeSession(session.start) }} - {{ formatTimeSession(session.end) }}
          </div>
        </td>
      </tr>
    </table>
    <div class="dialog" v-if="isShowSession">
      <div class="dialog-body">
        <div class="dialog-title">{{ this.sessionSelect.title }} - <span style="text-transform: capitalize;">{{ this.sessionSelect.type }}</span></div>
        <div class="dialog-description">{{ this.sessionSelect.description }}</div>
        <table class="info">
          <tr>
            <td class="text-header">Vaccinator:</td>
            <td>{{ this.sessionSelect.vaccinator }}</td>
          </tr>
          <tr>
            <td class="text-header">Start:</td>
            <td>{{ formatTimeSession(this.sessionSelect.start) }}</td>
          </tr>
          <tr>
            <td class="text-header">End:</td>
            <td>{{ formatTimeSession(this.sessionSelect.end) }}</td>
          </tr>
          <tr>
            <td class="text-header">Cost:</td>
            <td>{{ this.sessionSelect.cost }}.-</td>
          </tr>
        </table>
        <div class="dialog-footer">
          <button @click="isShowSession = false" class="close-btn">Close</button>
        </div>
      </div>
    </div>
    <div class="dialog dialog-w" v-if="isShowCart">
      <div class="dialog-body">
        <div class="dialog-title">
          {{ campaign_detail.name }}
        </div>
        <div class="list-ticket">
          <div class="ticket" :class="{'ticket-disable': !ticket.available}" v-for="ticket in campaign_detail.tickets" :key="ticket.id">
            <label>
              <div class="boxex">
                <input type="checkbox" :disabled="!ticket.available" v-model="ticket.isSelected" @change="changeTicketWithPurchase(ticket)">
              </div>
              <div class="label">
                <div class="label-line"><span>{{ ticket.name }}</span> <span>{{ ticket.cost }}.-</span></div>
                <div class="label-line" style="font-size: small; padding-top: 10px">{{ ticket.description || '&nbsp;' }}</div>
              </div>
            </label>
          </div>
        </div>
        <div class="dialog-services" v-if="purchase.ticket && services.length > 0">
          <div class="service-title">Select additonal services you want to purchase</div>
          <div class="workshop" v-for="service in services" :key="service.id">
            <label><input type="checkbox" v-model="service.isSelected" @change="changeServiceWithPurchase"> {{ service.title }} - {{ service.vaccinator }}</label>
          </div>
        </div>
        <div class="dialog-table-purchase">
          <table>
            <tr>
              <td>Campaign ticket:</td>
              <td><span v-if="purchase.ticket" id="event-cost">{{ purchase.ticket.cost }}</span></td>
            </tr>
            <tr>
              <td>Additonal services:</td>
              <td id="additonal-cost">{{ purchase.total_services || '' }}</td>
            </tr>
            <tr>
              <td style="border-top: 1px solid;">Total:</td>
              <td style="border-top: 1px solid;" id="total-cost">{{ purchase.total || '' }}</td>
            </tr>
          </table>
        </div>
        <div class="dialog-footer">
          <button @click="isShowCart = false" class="close-btn">Close</button>
          <button :disabled="isLoading" @click="actionPurchase" id="purchase" class="purchase-btn" :class="{'disable': !purchase.ticket}">Purchase</button>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { getDetailCampaign, getUserLoginObj, registrarion, getRegistrations } from '../api';
import { deleteStorageData, getStorageData, setStorageData } from '../http';

export default {
    name: "Campaign",
    data() {
      return {
        user_registration_session_ids: [],
        isLoading: false,
        msg_done: null,
        msg_err: null,
        isShowSession: false,
        isShowCart: false,
        sessionSelect: {},
        services: [],
        campaign_detail: {},
        purchase: {
          ticket: null,
          services: [],
          total: 0,
          total_services: 0
        }
      }
    },
    methods: {
      sessionDetail(session) {
        if(session.title) {
        this.isShowSession = true;
        this.sessionSelect = session;
        }
      },
      formatTimeSession(time) {
        var date_time = new Date(time);
        return `${date_time.getHours()}:${date_time.getMinutes()}`;
      },
      changeTicketWithPurchase(ticket) {
        if(ticket.available) {
          this.campaign_detail.tickets.forEach(ticket_item => {
            if(ticket.id !== ticket_item.id) {
              if(ticket_item.isSelected === true) {
                ticket_item.isSelected = undefined;
              }
            }
          });
          if(ticket.isSelected) {
            this.purchase.ticket = ticket;
          } else {
            this.purchase.ticket = null;
          }
        }
        this.caculationPurchase();
      },
      changeServiceWithPurchase() {
        var list = [];
        this.services.forEach(item => {
          if(item.isSelected) {
            list.push(item);
          }
        });
        this.purchase.services = list;
        this.caculationPurchase();
      },
      caculationPurchase() {
        // caculation total
        if(this.purchase.ticket === null) {
          this.purchase = {
            ticket: null,
            services: [],
            total: 0,
            total_services: 0
          };
        } else {
          this.purchase.total_services = 0;
          this.purchase.services.forEach(service => {
            this.purchase.total_services += service.cost;
          });
          this.purchase.total = this.purchase.ticket.cost + this.purchase.total_services;
        }
      },
      actionPurchase() {
        this.isLoading = true;
        registrarion(this.$route.params.organizer_slug, this.$route.params.campaign_slug, {
          ticket_id: this.purchase.ticket.id,
          session_ids: this.purchase.services.map(item => item.id)
        }).then(data => {
          this.isShowCart = false;
          this.isLoading = false;
          this.purchase.ticket.isSelected = false;
          this.purchase.services.forEach(element => {
            this.user_registration_session_ids.push(element.id);
          });
          this.purchase.services.forEach(item => item.isSelected = false);
          this.purchase = {
            ticket: null,
            services: [],
            total: 0,
            total_services: 0
          };
          this.msg_done = data.message;
          setTimeout(() => {
          this.msg_done = null;
          }, 5000);
        }).catch((data) => {
          this.isShowCart = false;
          this.isLoading = false;
          this.purchase.ticket.isSelected = false;
          this.purchase.services.forEach(item => item.isSelected = false);
          this.purchase = {
            ticket: null,
            services: [],
            total: 0,
            total_services: 0
          };
          this.msg_err = data.message;
          setTimeout(() => {
          this.msg_err = null;
          }, 5000);
        });
      }
    },
    mounted() {
      const isShowCart = getStorageData('is_show_cart');
      if(isShowCart) {
        deleteStorageData('is_show_cart');
        this.isShowCart = true;
      }
    },
    created() {
      var user_obj = getUserLoginObj();
      this.$emit("setBtn", {
        title: 'Register for this campaign',
        fn: () => {
          if(user_obj.isLogin === true) {
            this.isShowCart = true;
          } else {
            setStorageData('is_show_cart', true);
            setStorageData('backto_link_campaign_registration', JSON.stringify(this.$route.params));
            this.$router.push({name: "Login"});
          }
        }
      });
      getDetailCampaign(this.$route.params.organizer_slug, this.$route.params.campaign_slug).then(data => {
        this.$emit("changeTitle", data.name)
        // pross data session
        var maxCountSession = 0;
        var sessionRows = [];
        data.areas.forEach(area => {
          area.places.forEach(place => {
            for (let index = 0; index < place.sessions.length; index++) {
              if(place.sessions[index].type == 'service') {
                this.services.push(place.sessions[index]);
              }
              if(maxCountSession < place.sessions.length) {
                for (let index = 0; index < sessionRows.length; index++) {
                  for (let i = 0; i < (place.sessions.length - maxCountSession); i++) {
                    sessionRows[index].push({id: place.sessions.length + i});
                  }
                }
                maxCountSession = place.sessions.length;
              } else {
                  for (let i = 0; i < (maxCountSession - place.sessions.length); i++) {
                    place.sessions.push({id: place.sessions.length + i});
                  }
              }
              sessionRows.push(place.sessions);
            }
          })
        })
        this.campaign_detail = data;
        if(user_obj.isLogin === true) {
          getRegistrations().then(data_registration => {
            // Get registration with campaign
            data_registration.forEach(item => {
              if(item.campaign.id === this.campaign_detail.id) {
                this.user_registration_session_ids = item.session_ids
              }
            })
          })
        }
      })
    }
}
</script>

<style>
.list-ticket {
  margin: 10px 20px;
  display: grid;
  grid-template-columns: 1fr 1fr 1fr;
  grid-column-gap: 10px;
}
.list-ticket .ticket {
  border: 1px solid #000000;
  padding: 10px;
  cursor: pointer;
}
.list-ticket .ticket label{
  display: flex;
  align-items: center;
  cursor: pointer;
}
.list-ticket .ticket label .label-line{
  display: flex;
  justify-content: space-between;
  cursor: pointer;
}
.label {
  width: 100%;
}
.boxex {
  margin-right: 10px;
}
.text-header {
  font-weight: bold;
}
.info {
  border: none !important;
}
.box-responsive {
  width: 100%;
  overflow-x: scroll;
}
.box-done {
    background: #4caf50;
    color: white;
    padding: 10px;
    margin-bottom: 10px;
    border-radius: 5px;
}
.box-err {
    background: #f44336;
    color: white;
    padding: 10px;
    margin-bottom: 10px;
    border-radius: 5px;
}
table, th {
  border: 1px solid black;
}
th {
  padding: 10px;
  background: #e0e0e0;
}
td {
  padding: 10px;
  min-width: 200px;
}
td div{
  padding: 5px;
  cursor: pointer;
}
.active {
  border: 1px solid green;
}
.table-campaign {
  border-collapse: collapse;
  width: 100%;
}
.column-area {
  width: 20%;
}
.column-place {
  width: 20%;
}
.column-session {
  width: 60%;
}
.text-center {
  text-align: center;
}
.dialog {
  position: absolute;
  top: 0;
  left: 0;
  display: flex;
  justify-content: center;
  align-items: flex-start;
  width: 100vw;
  height: 100vh;
  background: rgba(0, 0, 0, 0.562);
}
.dialog-body {
  border: 1px solid #e0e0e0;
  border-radius: 5px;
  background: white;
  margin-top: 20px;
  width: 500px;
}
.dialog-w .dialog-body {
  width: 900px;
}
.dialog-footer {
  display: flex;
  padding: 10px 20px;
  justify-content: flex-end;
  background: #e0e0e0;
}
.dialog-title {
  padding: 10px 20px;
  font-weight: bold;
  font-size: 20px;
}
.dialog-description {
  padding: 10px 20px;
  text-align: justify;
}
.ticket-disable {
  background: #e0e0e0;
  opacity: 0.5;
}
.dialog-footer .close-btn {
  padding: 10px 20px;
  color: white;
  border: none;
  background: #03b6ff;
  cursor: pointer;
  border-radius: 5px;
}
.dialog-footer .close-btn:hover {
  background: #0398d3;
}
.purchase-btn {
  padding: 10px 20px;
  color: white;
  border: none;
  background: #098f14;
  cursor: pointer;
  border-radius: 5px;
  margin-left: 5px;
}
.disable {
  cursor: no-drop;
  background: #939393;
}
.dialog-table-purchase {
  padding: 10px 20px;
  display: flex;
  justify-content: flex-end;
}
.dialog-table-purchase table{
  background: aliceblue;
}
.dialog-table-purchase td {
  min-width: 100px;
  text-align: right;
}
.dialog-services {
  padding: 10px 20px;
}
</style>